\ Collected Algorithms from ACM, Volume 1 Algorithms 1-220,
\ 1980; Association for Computing Machinery Inc., New York,
\ ISBN 0-89791-017-6

\ (c) Copyright 1994 Everett F. Carter.  Permission is granted by the
\ author to use this software for any application provided this
\ copyright notice is preserved.

[UNDEFINED] today [IF]
VARIABLE da
VARIABLE mo
VARIABLE yr

[UNDEFINED] tz [IF]
1 3600 [*] CONSTANT tz                 \ Middle European Timezone
[THEN]

: JDAY ( d m y -- jd)                  \ day, month, year to Julian date
  SWAP DUP 2 > IF 3 - SWAP ELSE 9 + SWAP 1- THEN ROT >R SWAP >R 100 /MOD >R
  1461 * 2/ 2/ R> 146097 * 2/ 2/ + R> 153 * 2 + 5 / + R> + 1721119 +
;

: JDATE ( jd -- d m y)                 \ Julian date to day, month, year
  1721119 - 2* 2* 1- dup 146097 / dup yr ! 146097 * - 2/ 2/ 2* 2* 3 + 1461 /mod
  SWAP 4 + 4 / 5 * 3 - 153 /MOD mo ! 5 + 5 /  da ! yr @ 100 * + yr !
  mo @ 10 < IF 3 mo +! ELSE -9 mo +!  1 yr +! THEN da @ mo @ yr @
;

: (LOCAL) time tz + 86400 ;
: TODAY   (LOCAL) / 2440588 + jdate ;
: NOW     (LOCAL) mod 3600 /mod >r 60 /mod r> ; 
: WEEKDAY jday 7 mod ; 

[DEFINED] 4TH# [IF]
hide (LOCAL)
hide da
hide mo
hide yr
[THEN]
[THEN]

